- include_role:
    name: prometheus
    tasks_from: dashboards.yaml
  when:
  - do_exporters
  - grafana_public_address | default(False)
  - grafana_public_address != 'not deployed'
- name: Set Jitsi API Facts
  changed_when: False
  set_fact:
    dash_list: "{{ has_dash | default([]) | unique }}"
    jitsi_priv_address: "https://{{ jitsi_name }}.{{ namespace }}.svc.{{ cluster_domain }}:443"
    jitsi_pub_address: "https://{{ jitsi_fqdn }}"
    jvb_pub_address: "udp://{{ jvb_found_external_ip
                                 if (jvb_found_external_ip)
                                 else 'any-node-address'
                            }}:{{ jvb_external_port }}"
    prosody_priv_address: "xmpp://{{ prosody_name }}.{{ namespace }}.svc.{{ cluster_domain }}:5222"
    prosody_bosh_address: "http://{{ prosody_name }}.{{ namespace }}.svc.{{ cluster_domain }}:5380"
- block:
  - name: Reads Operator Token
    args:
      chdir: /run/secrets/kubernetes.io/serviceaccount
    changed_when: False
    register: api_token
    shell: cat token
  - name: Marks Jitsi Provisionned
    no_log: True
    uri:
      body: |
        {
          "status": {
            "bosh": "{{ prosody_bosh_address }}",
            "dashboards": {{ dash_list }},
            "internal": "{{ jitsi_priv_address }}",
            "public": "{{ jitsi_pub_address }}",
            "ready": true,
            "videobridge": "{{ jvb_pub_address }}",
            "xmpp": "{{ prosody_priv_address }}"
          }
        }
      body_format: json
      headers:
        Authorization: "Bearer {{ api_token.stdout_lines[0] }}"
        Content-Type: application/merge-patch+json
      method: PATCH
      return_content: yes
      url: "https://kubernetes.default.svc.{{ cluster_domain }}/apis/{{ cr_apivers }}/namespaces/{{ namespace }}/jitsies/{{ cr_name }}/status"
      validate_certs: False
  when:
  - jitsi_crd is defined
  - jitsi_crd.resources is defined
  - jitsi_crd.resources | length > 0
  - >
      jitsi_crd.resources[0].status is not defined
      or (jitsi_crd.resources[0].status is defined
          and (jitsi_crd.resources[0].status.ready is not defined
               or (jitsi_crd.resources[0].status.bosh | default('')) != prosody_bosh_address
               or ((jitsi_crd.resources[0].status.dashboards | default([])) | difference(dash_list)) | length > 0
               or (dash_list | difference((jitsi_crd.resources[0].status.dashboards | default([])))) | length > 0
               or (jitsi_crd.resources[0].status.internal | default('')) != jitsi_priv_address
               or (jitsi_crd.resources[0].status.public | default('')) != jitsi_pub_address
               or (jitsi_crd.resources[0].status.videobridge | default('')) != jvb_pub_address
               or (jitsi_crd.resources[0].status.xmpp | default('')) != prosody_priv_address))
